/****************************************
 * Pilotage d'actionneurs Interface-Z
 * carte 2 Servomoteurs 4 PWM (lampes, etc)
 * mode 128 pas - 7 bits.
 *****************************************/

// Importer la library the Midibus
// http://smallbutdigital.com/themidibus.php
import themidibus.*; 
MidiBus myBus; 

void setup()
{  
  size(360, 180);
  // Liste des peripheriques Midi detectes
  MidiBus.list(); 
  // MidiBus(this, port entrant In, port sortant Out)
  // CHOISIR LE BON NUMERO DE SORTIE
  myBus = new MidiBus(this, -1, 2);
}

int[] actions = new int[16];
float angle = 0;

void draw()
{  
  angle = angle + 0.01;

  actions[0] = int(map(sin(angle), -1.0, 1.0, 0, 16383)) ; // Premiere lampe
  actions[1] = int(map(sin(angle + PI/2), -1.0, 1.0, 0, 16383)) ;
  actions[2] = int(map(sin(angle + PI), -1.0, 1.0, 0, 16383)) ;
  actions[3] = int(map(sin(angle + 3*PI/2), -1.0, 1.0, 0, 16383)) ;

  actions[4] = int(map(sin(angle), -1.0, 1.0, 100, 7800)) ; // Premier servo
  actions[5] = int(map(sin(angle + PI/2), -1.0, 1.0, 100, 7800)) ;
  actions[6] = int(map(sin(angle + PI), -1.0, 1.0, 100, 7800)) ;
  actions[7] = int(map(sin(angle + 3*PI/2), -1.0, 1.0, 100, 7800)) ;    

  //sendControllerChange(canal, numero, valeur)
  for (int i=0; i<8; i++) {
    actions[i+8] = int(actions[i] / 128);
    actions[i] = actions[i] % 128;
    myBus.sendControllerChange(0, i+8, actions[i+8]);
    myBus.sendControllerChange(0, i, actions[i]); // (canal, numero, valeur)
  }
}

